/*
 *	$Id: netcalc_server.c,v 1.3 2005/04/28 21:37:44 rh Exp $
 *
 * netcalc_server: top level module for a simple networked RPN
 *                 calculator
 */

#include <stdio.h>
#include <stdlib.h>

#include "calc_server.h"

#define DEFAULT_PORT 12345

/*
 * print the usage of the program and exit
 *
 * parameters:
 *	- prog: a string containing the program name as called
 *
 * return values:
 *	none
 */
void usage(char *prog)
{
	fprintf(stderr, "Usage: %s [port number]\n", prog);

	exit(EXIT_FAILURE);
}


/*
 * main function
 *
 * parameters:
 *	- argv[1]: an optional port number
 *
 * return values:
 *	EXIT_SUCCESS in case of success, EXIT_FAILURE otherwise
 */
int main(int argc, char *argv[])
{
	int port = DEFAULT_PORT;

	switch (argc)
	{
		case 2:
			port = atoi(argv[1]);
		case 1:
			break;

		default:
			usage(argv[0]);
	}

	return calc_server(port);
}
