/*
 *	$Id: stack.h,v 1.2 2005/04/26 23:45:43 rh Exp $
 *
 * a simple, incomplete ubiquitous stack data type
 *
 */

#ifndef _STACK_H_
#define _STACK_H_

#define STACK_DEFAULT_CAPACITY	100

typedef union
{
	long		long_value;
	double		double_value;
	void		*pointer_value;
} StackValue;

typedef struct
{
	StackValue	*value;		/* the actual stack */
	int		capacity;	/* number of elements allocated */
	int		n;		/* number of elements on stack */
} Stack;

/* memory management and initialisation */
Stack *new_Stack(void);
Stack *stack_Alloc(int);
Stack *stack_Init(Stack *);
void stack_Release(Stack *);

/* house keeping */
int stack_numberOfElements(Stack *);
#define stack_isEmpty(stack) (stack_numberOfElements(stack) == 0)
#define stack_isNonEmpty(stack) (stack_numberOfElements(stack) != 0)

/* double values */
Stack *stack_pushDouble(Stack *, double);
double stack_popDouble(Stack *);

/* other types would work the same way ... */

#endif /* _STACK_H_ */
